#ifndef KEXEC_H
#define KEXEC_H

struct kexec_segment {
	void *buf;
	size_t bufsz;
	void *mem;
	size_t memsz;
};

long kexec(void *entry, long nr_segments, struct kexec_segment *segments);

struct memory_range {
	unsigned long start, end;
};

int get_memory_ranges(struct memory_range **range, int *ranges);
int valid_memory_range(struct kexec_segment *segment);
int sort_segments(struct kexec_segment *segment, int segments);
int locate_arguments(struct kexec_segment *segment, int segments, 
	size_t align, unsigned long max);

struct file_type {
	const char *name;
	int (*probe)(FILE *file);
	int (*load)(FILE *file, char *cmd_line, 
		void **entry, struct kexec_segment **segments, int *nr_segments);
};

extern struct file_type file_type[];
extern int file_types;
extern int debug;

#endif /* KEXEC_H */
