.data
.code32
	.globl setup32_start, setup32_end, setup32_size
	.globl setup32_regs
setup32_start:
_reloc = .
	/* Compute where I am running at */
	call	1f
1:	popl	%ebx
	subl	$(1b - _reloc), %ebx

	/* align the code, I feel better when word load & store instructions
	 * are aligned.
	 */
	nop

	/* Relocate the code */
	addl	%ebx, reloc1 - _reloc(%ebx)
	addl	%ebx, reloc2 - _reloc(%ebx)

	/* Execute a serializing instruction to ensure
	 * My self modifing code works
	 */
	movl	%cr0, %eax
	movl	%eax, %cr0

	/* Load the registers */
	movl	eax - _reloc(%ebx), %eax
	movl	ecx - _reloc(%ebx), %ecx
	movl	edx - _reloc(%ebx), %edx
	movl	esi - _reloc(%ebx), %esi
	movl	edi - _reloc(%ebx), %edi
	movl	esp - _reloc(%ebx), %esp
	movl	ebp - _reloc(%ebx), %ebp

	.byte 0x8b, 0x1d	# movl ebx,  %ebx
reloc1:	.long ebx - _reloc

	nop
	nop

	.byte 0xff, 0x25	# jmpl *(eip)
reloc2:	.long eip - _reloc

	.balign 4
setup32_regs:
eax:	.long 0x00000000
ebx:	.long 0x00000000
ecx:	.long 0x00000000
edx:	.long 0x00000000
esi:	.long 0x00000000
edi:	.long 0x00000000
esp:	.long 0x00000000
ebp:	.long 0x00000000
eip:	.long 0x00000000
setup32_end:
setup32_size:
	.long setup32_end - setup32_start
